
\chapter{ Our 3D Parts in FreeCAD \label{ch:model-cad} } 

This appendix chapter is meant to be a guide on how to use FreeCAD to make 3D CAD models similar to the ones that were used in this thesis. We explain why we chose FreeCAD, describe the user interface, and provide the step-by-step instructions on making a magnet tray similar to Setup-3. The parts are available for download at: \\

\archiveBaseURL{}\url{/t17/FreeCAD-Files.zip} \\

\begin{figure}[h] 
	\begin{center} 
		\includegraphics[width=6in]{Figures/May-10/FreeCAD-views.png} 
	\end{center} 
	\caption{ The FreeCAD user interface. FreeCAD is still in early stages of development, but it is quite useable and has a few features. \label{scr:apr6:FreeCAD-part-view} } 
\end{figure} 

A little bit about why we chose FreeCAD. We had to choose a 3D CAD software for designing our models. We considered AudoDesk Fusion 360, OnShape, Blender, and FreeCAD. Fusion 360 and OnShape require sign-up and are web-based. Web-based software has the limit of how fast the browser can run it, but we wanted software that would run natively on the operating system and not be slowed by browser and JavaScript limits. Blender is such a software that runs natively, but it offers essentially no ability to change objects' dimensions once they are created. We still used Blender for assembling artistic drawings, such as the ones in \fig{fig:dis-setup-03}, but, for technical drawings, FreeCAD was left. \\

% \fig{fig:both-setups-side-by-side} 

%\begin{figure}[h] 
%	\begin{center} 
%		\includegraphics[width=6in]{Figures/May-10/csv-text-import-w-tab.png} 
%	\end{center} 
%	\caption{ The ``magnet-arrangement.csv'' file shows the arrangement parameters that can be copy-pasted to FreeCAD. \label{scr:may10:magnet-arrangement} } 
%\end{figure} 

% \fig{scr:apr6:FreeCAD-part-view}

FreeCAD has a nice user interface, shown in \fig{scr:apr6:FreeCAD-part-view}. The user interface has so many controls that they would not all fit on one toolbar. Thus, FreeCAD categorizes the controls into what are called \textit{workbenches}, and shows the user only the controls that belong to the selected workbench. The workbench selection is near the top-right; it is that drop-down menu that says ``Part'' in the screenshot. The most interesting workbenches to us are the ``Spreadsheet,'' ``Part Design,'' and ``Part.'' For navigation, click-drag the middle mouse button (MMB) to move around, and shift-right-click and drag the right mouse button (RMB) to orbit. Scroll (MMB) to zoom on the part. To select a face (one flat side) of an object, click on the face in the 3D viewport. Click again to select the whole object. Alternatively, click on an object's name in the tree view (a hierarchichal view of the CAD file on the left) to select the whole object. \\

\begin{figure}[h] 
	\begin{center} 
		\includegraphics[width=6in]{Figures/May-10/FreeCAD-ring.png} 
	\end{center} 
	\caption{ The ``one-ring-hole-v1'' FreeCAD file has a spreadsheet with editable ring parameters. \label{scr:may10:FreeCAD-ring} } 
\end{figure} 

Once the magnet arrangement parameters are figured out using user-optimize, follow the steps to make the CAD model: 

\begin{enumerate} 
	\item Open the ``magnet-arrangement.csv'' file generated by the user-optimize Python code. Double-clicking the CSV file will probably bring up a dialog similar to the one shown in \fig{user-optimize:scr:may10:magnet-arrangement}; ensure the ``Tab'' and ``Comma'' checkboxes are checked, and click OK. A new spreadsheet window should open with all the parameters. \label{step:open-params} 
	\item Download and extract the ZIP archive with the starting-point FreeCAD files at: \archiveBaseURL{}\url{/t17/FreeCAD-Files.zip} 
	\item Open ``magnet-tray-starting-material.FCStd''; if it does not open with FreeCAD but rather an ``Open with'' dialog pops up, choose ``Select a program from a list of installed programs,'' browse to the FreeCAD folder, then to the ``bin'' folder, and choose ``FreeCAD.exe'' , whose icon is a red ``F'' with a blue gear next to it. \label{step:open-base} 
	\item Save this as a new FreeCAD file. Go to the ``File'' menu, then ``Save As,'' and save it somewhere, in case FreeCAD crashes. 
	\item In the workbench selection drop-down, switch into the ``Part'' workbench. This is required to use the ``Boolean'' tool. 
	\item Double-click on the ``Params'' spreadsheet in the tree view. 
	\item Choose a total height for the magnet tray (must fit all magnets vertically), and enter it into the ``Total Tray Height'' row's ``Value'' column. \label{step:enter-tot-tray-dz} 
	\item Go back to the file browser window with the FreeCAD files, and double-click on the ``one-ring-hole-v1.FCStd'' file; it should open in FreeCAD in a new window. The ring might be out of view when first opened, but use the MMB to zoom out to see the whole ring. \label{step:open-ring} 
	\item Open the spreadsheet; this may be done by double-clicking the ``Params'' spreadsheet item under ``one-ring-hole-v1'' in the tree view near the top-left, as seen in \fig{scr:may10:FreeCAD-ring}. 
	\item Enter the same total tray height from step \ref{step:enter-tot-tray-dz} into this spreadsheet. 
	\item Also in this spreadsheet, under ``Water Cell Floor Thickness,'' make sure the floor thickness is correct. Also check the ``Water Level'' value. \label{step:check-waterz-floordz} 
	\item For each ring of magnets (each row of the parameters table), perform steps \ref{step:begin-each-ring} through \ref{step:end-each-ring}: 
	\item Go to the window opened in step \ref{step:open-ring}. \label{step:begin-each-ring} 
	\item Go to the spreadsheet from step \ref{step:open-params}. Copy the number from the ``Magnets in Ring'' column. \label{step:copy-dimless-value-from-sheet} 
	\item Go to the ring-hole window from step \ref{step:open-ring}. In the spreadsheet, click the cell in the ``Value'' column and the ``Number of Magnets in the Ring'' row. At the top of the spreadsheet, there is a text input called ``Contents;'' click inside it, hit Ctrl-A to select all, hit Backspace, and then hit Ctrl-V to paste the value from the spreadsheet. If the value pasted has a space after it, hit Backspace to remove it (for some reason FreeCAD complains when there is an invisible newline character pasted with the value, but this seems to fix it; spaces are fine, but pasting from a spreadsheet seems to insert invisible newline spaces that give FreeCAD trouble). Hit Enter to set the cell's value. \label{step:paste-value-into-FreeCAD} 
	\item Again, go to the spreadsheet from step \ref{step:open-params}. Copy the number from the ``''Radius (mm)'' column. \label{step:copy-mm-val} 
	\item Return to the window from step \ref{step:open-ring}, and follow \textit{most} of step \ref{step:paste-value-into-FreeCAD} but for the ``Ring Radius'' row of the FreeCAD spreadsheet. The difference here is that this radius value should have units. Thus, after hitting Backspace to remove extra space, but before hitting the final Enter, type ``mm'' into the text input. So, in other words, paste the number representing the radius, hit Backspace to remove extra space, type ``mm'', and hit Enter. The ``mm'' lets FreeCAD know that it should treat the value as a length in millimeters. \label{step:paste-mm-val} 
	\item Follow the same steps \ref{step:copy-mm-val} and \ref{step:paste-mm-val} to copy the ring height (units are \si{mm}) into FreeCAD. 
	\item Follow steps \ref{step:copy-dimless-value-from-sheet} and \ref{step:paste-value-into-FreeCAD} to copy the ring rotation angle (as far as FreeCAD is concerned, this one is dimensionless!) about the Z-axis into FreeCAD. 
	\item Finally, here is the step where thinking is involved: choose whether or not a spacer is needed for this ring, and enter a ``1'' (yes) or ``0'' (no) into the ``Use Spacer'' row in the FreeCAD spreadsheet. This just affects how the resulting ring area is shaped. We used ``1'' for all rings except the deep ring number 10 in Setup-3, which would mess up the magnet tray if we would have used a ``1'' for that ring. 
	\item See the tabs at the very bottom of the window. Click on the ``one-ring-hole-v1'' tab with the FreeCAD icon to see how the model looks. 
	\item In the tree view near the top-left, click on ``AntiRing'' to select it. %, and then ctrl-click on ``OneCutRescueHolePins'' to add that to the selection. 
	\item Hit \texttt{Ctrl + C} to copy the selection. When prompted to copy the dependencies, click ``Yes'' to copy them too (since we are about to paste the selection into a different FreeCAD model). 
	\item Go to the FreeCAD window from step \ref{step:open-base}. 
	\item Hit \texttt{Ctrl + V} to paste. 
	\item In the tree view, click on ``StartingPart'' to select it. Then \texttt{Ctrl}-click the ``AntiRing'' part that was just pasted. \label{step:select-part-to-cut-ring} 
	\item On one of the toolbars at the top, there should be an icon with two blue balls next to each other; hovering the mouse over that icon shows a tooltip, saying ``Run a boolean operation with two shapes selected.'' This is the boolean tool. Click on it. 
	\item Select the ``Difference'' radio button, and click ``Apply.'' Then click ``Close'' next to ``Apply.'' 
	\item Congratulations! You have cut out the slots and the rescue holes for a ring of magnets! Hit ctrl-S to save your work in case FreeCAD crashes!
	\item In cutting out more rings, select the latest part (rather than the original ``StartingPart'') in step \ref{step:select-part-to-cut-ring}. \label{step:end-each-ring} 
	\item After all the rings are subtracted in this way, select the resulting finished part. Go to the ``File'' menu, and select ``Export;'' or hit \texttt{Ctrl + E}. Choose ``STL'' for the export format. 
	\item The STL file may be 3D printed from the Cura software, but be sure to first flip the piece over in Cura - the exported STL will be upside down! 
	\item To flip the part in Cura, click on it. Click ``Rotate'' at the bottom, and drag one of the axes until Cura says ``180'' next to the cursor. If no rotation seems to be happening, you may have selected the vertical axis to rotate about; try a different axis. 
	\item Note that, depending on the number of magnet slots and overall complexity, it may take Cura up to 5 or 10 minutes to generate the 3D printer GCode. Please be patient. 
	\item You're done! 
\end{enumerate} 

That was the magnet tray. For the water cell, open the ``water-cell-v6.FCStd'' file and double-click on the ``CellParams'' spreadsheet in the tree view. Change any parameters necessary, such as the water inner or outer radius, or the floor thickness. Be sure that the floor thickness and water level from here is equal to the same values entered in step \ref{step:check-waterz-floordz} above. To export it for 3D printing, go to the tree view and select the three parts: ``CenteringShell,'' ``AirflowShield,'' and ``PartTop-WaterCellWithBothWallWindows.'' Then use the ``File'' menu or hit \texttt{Ctrl + E} to export an STL. \\

To learn how to design parts from scratch, see the FreeCAD tutorials, such as the Part Design tutorial \cite{FreeCAD_BasicPartDesignTutorial}. The tutorial by Mark J. Norton is a little bit old now, but it is also quite useful \cite{Norton_UsingFreeCAD}. \\





